<?php
/*
 * --------------------------------------------------------------------------------
   Weblogicx India  - K2 Store v 2.4
 * --------------------------------------------------------------------------------
 * @package		Joomla! 1.5x
 * @subpackage	K2 Store
 * @author    	Weblogicx India http://www.weblogicxindia.com
 * @copyright	Copyright (c) 2010 - 2015 Weblogicx India Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 * @link		http://weblogicxindia.com
 * --------------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

// Load K2 language file
$lang = &JFactory::getLanguage();
$lang->load('com_k2store');

$db = & JFactory::getDBO();
$status = new JObject();
$status->modules = array();
$status->plugins = array();
$src = $this->parent->getPath('source');


// install modules

$modules = &$this->manifest->getElementByPath('modules');
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {
	foreach ($modules->children() as $module) {
		$mname = $module->attributes('module');
		$client = $module->attributes('client');
		if(is_null($client)) $client = 'site';
		($client=='administrator')? $path=$src.DS.'administrator'.DS.'modules'.DS.$mname: $path = $src.DS.'modules'.DS.$mname;
		$installer = new JInstaller;
		$result = $installer->install($path);
		$status->modules[] = array('name'=>$mname,'client'=>$client, 'result'=>$result);
	}
}

// install plugins
$plugins = &$this->manifest->getElementByPath('plugins');
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin) {
		$pname = $plugin->attributes('plugin');
		$pgroup = $plugin->attributes('group');
		$path = $src.DS.'plugins'.DS.$pgroup;
		$installer = new JInstaller;
		$result = $installer->install($path);
		$status->plugins[] = array('name'=>$pname,'group'=>$pgroup, 'result'=>$result);

		$query = "UPDATE #__plugins SET published=1 WHERE element=".$db->Quote($pname)." AND folder=".$db->Quote($pgroup);
		$db->setQuery($query);
		$db->query();
	}
}


// Database modifications [start]
$db = &JFactory::getDBO();
$fields = $db->getTableFields('#__k2store_orders');
if (!array_key_exists('shipping_method_id', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `shipping_method_id` INT(11) NOT NULL default '0' AFTER `order_id`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('orderpayment_tax', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `orderpayment_tax` decimal(15,5) NOT NULL DEFAULT '0.00000' AFTER `orderpayment_amount`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('order_total', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `order_total` decimal(15,5) NOT NULL DEFAULT '0.00000' AFTER `orderpayment_tax`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('order_subtotal', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `order_subtotal` decimal(15,5) NOT NULL DEFAULT '0.00000' AFTER `order_total`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('order_tax', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `order_tax` decimal(10,2) NOT NULL DEFAULT '0.00' AFTER `order_subtotal`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('order_shipping', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `order_shipping` decimal(10,2) NOT NULL AFTER `order_tax`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('order_discount', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `order_discount` decimal(10,2) NOT NULL AFTER `order_shipping`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('order_state_id', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `order_state_id` INT(11) NOT NULL AFTER `order_state`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('ip_address', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `ip_address` varchar(255) NOT NULL AFTER `order_state_id`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('customer_note', $fields['#__k2store_orders'])) {
	$query = "ALTER TABLE #__k2store_orders ADD `customer_note` text NOT NULL AFTER `ip_address`";
	$db->setQuery($query);
	$db->query();
}

//end of orders table

//start orderitems table. The existing orderdetails table is converted into orderitems

//first rename the table
$details_fields = $db->getTableFields('#__k2store_orderdetails');

//if the order details table exists, rename it
if(count($details_fields)) { 

	$query = "RENAME TABLE #__k2store_orderdetails TO #__k2store_orderitems";
	$db->setQuery($query);
	$db->query();
} else {
//create it
	$query = "	
	CREATE TABLE IF NOT EXISTS `#__k2store_orderitems` (
  `orderitem_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) DEFAULT NULL,
  `product_id` int(11) DEFAULT NULL,
  `orderitem_attributes` text NOT NULL COMMENT 'A CSV of productattributeoption_id values, always in numerical order',
  `orderitem_attribute_names` text NOT NULL COMMENT 'A CSV of productattributeoption_name values',
  `orderitem_sku` varchar(64) NOT NULL DEFAULT '',
  `orderitem_name` varchar(64) NOT NULL DEFAULT '',
  `orderitem_quantity` int(11) DEFAULT NULL,
  `orderitem_price` decimal(15,5) NOT NULL DEFAULT '0.00000' COMMENT 'Base price of the item',
  `orderitem_attributes_price` varchar(64) NOT NULL COMMENT 'The increase or decrease in price per item as a result of attributes. Includes + or - sign',
  `orderitem_discount` decimal(15,5) NOT NULL DEFAULT '0.00000' COMMENT 'Coupon discount applied to each item',
  `orderitem_final_price` decimal(15,5) NOT NULL DEFAULT '0.00000' COMMENT 'Price of item inclusive of quantity, attributes, tax, and shipping',
  `orderitem_tax` decimal(15,5) NOT NULL DEFAULT '0.00000',
  `orderitem_shipping` decimal(12,5) NOT NULL DEFAULT '0.00000',
  `orderitem_shipping_tax` decimal(12,5) NOT NULL DEFAULT '0.00000',
  `orderitem_status` char(1) DEFAULT NULL,
  `modified_date` datetime NOT NULL COMMENT 'GMT',
  PRIMARY KEY (`orderitem_id`),
  KEY `idx_order_item_order_id` (`order_id`)
  ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
  ";
  $db->setQuery($query);
  $db->query();
}	
	

// now start altering table fields
$fields = $db->getTableFields('#__k2store_orderitems');

//lets change some field names
if (array_key_exists('id', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems CHANGE `id` `orderitem_id` int(11) NOT NULL AUTO_INCREMENT";
	$db->setQuery($query);
	$db->query();
}

if (array_key_exists('itemid', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems CHANGE `itemid` `product_id` int(11) DEFAULT NULL";
	$db->setQuery($query);
	$db->query();
}

if (array_key_exists('itemname', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems CHANGE `itemname` `orderitem_name` varchar(64) NOT NULL DEFAULT ''";
	$db->setQuery($query);
	$db->query();
}

if (array_key_exists('itemprice', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems CHANGE `itemprice` `orderitem_price` decimal(15,5) NOT NULL DEFAULT '0.00000' COMMENT 'Base price of the item'";
	$db->setQuery($query);
	$db->query();
}

if (array_key_exists('quantity', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems CHANGE `quantity` `orderitem_quantity` int(11) DEFAULT NULL";
	$db->setQuery($query);
	$db->query();
}

if (array_key_exists('total', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems CHANGE `total` `orderitem_final_price` decimal(15,5) NOT NULL DEFAULT '0.00000' COMMENT 'Price of item inclusive of quantity, attributes, tax, and shipping'";
	$db->setQuery($query);
	$db->query();
}

if (array_key_exists('tax_total', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems CHANGE `tax_total` `orderitem_tax` decimal(15,5) NOT NULL DEFAULT '0.00000'";
	$db->setQuery($query);
	$db->query();
}

//lets add some fields

if (!array_key_exists('orderitem_attributes', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_attributes` text NOT NULL COMMENT 'A CSV of productattributeoption_id values, always in numerical order' AFTER `product_id`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('orderitem_attribute_names', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_attribute_names` text NOT NULL COMMENT 'A CSV of productattributeoption_name values' AFTER `orderitem_attributes`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('orderitem_sku', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_sku` varchar(64) NOT NULL DEFAULT '' AFTER `orderitem_attribute_names`";
	$db->setQuery($query);
	$db->query();
}


if (!array_key_exists('orderitem_attributes_price', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_attributes_price` varchar(64) NOT NULL COMMENT 'The increase or decrease in price per item as a result of attributes. Includes + or - sign' AFTER `orderitem_price`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('orderitem_tax', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_tax` decimal(15,5) NOT NULL DEFAULT '0.00000' AFTER `orderitem_final_price`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('orderitem_discount', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_discount` decimal(15,5) NOT NULL DEFAULT '0.00000' COMMENT 'Coupon discount applied to each item' AFTER `orderitem_attributes_price`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('orderitem_shipping', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_shipping` decimal(12,5) NOT NULL DEFAULT '0.00000' AFTER `orderitem_tax`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('orderitem_shipping_tax', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_shipping_tax` decimal(12,5) NOT NULL DEFAULT '0.00000' AFTER `orderitem_shipping`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('orderitem_status', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `orderitem_status` char(1) DEFAULT NULL AFTER `orderitem_shipping_tax`";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('modified_date', $fields['#__k2store_orderitems'])) {
	$query = "ALTER TABLE #__k2store_orderitems ADD `modified_date` datetime NOT NULL COMMENT 'GMT' AFTER `orderitem_status`";
	$db->setQuery($query);
	$db->query();
}

//add the key
$query = "SHOW INDEX FROM #__k2store_orderitems";
$db->setQuery($query);
$indexes = $db->loadObjectList();
$indexExists = false;
foreach ($indexes as $index){
	if ($index->Key_name=='idx_order_item_order_id')
		$indexExists = true;
}

if (!$indexExists){
	$query = "ALTER TABLE #__k2store_orderitems ADD KEY `idx_order_item_order_id` (`order_id`)";
	$db->setQuery($query);
	$db->query();
}

//end of db modifications
?>

<?php $rows = 0;?>
<img src="components/com_k2store/images/k2store-icon.gif" width="109" height="48" alt="K2 Store Component" align="right" />
<h2><?php echo JText::_('K2 Store Installation Status'); ?></h2>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" colspan="2"><?php echo JText::_('Extension'); ?></th>
			<th width="30%"><?php echo JText::_('Status'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
			<td class="key" colspan="2"><?php echo 'K2 '.JText::_('Component'); ?></td>
			<td><strong><?php echo JText::_('Installed'); ?></strong></td>
		</tr>
		<?php if (count($status->modules)) : ?>
		<tr>
			<th><?php echo JText::_('Module'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->modules as $module) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td><strong><?php echo ($module['result'])?JText::_('Installed'):JText::_('Not installed'); ?></strong></td>
		</tr>
		<?php endforeach;?>
		<?php endif;?>
		<?php if (count($status->plugins)) : ?>
		<tr>
			<th><?php echo JText::_('Plugin'); ?></th>
			<th><?php echo JText::_('Group'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->plugins as $plugin) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key"><?php echo ucfirst($plugin['group']); ?></td>
			<td><strong><?php echo ($plugin['result'])?JText::_('Installed'):JText::_('Not installed'); ?></strong></td>
		</tr>
		<?php endforeach; ?>
		<?php endif; ?>
	</tbody>
</table>
