<?php
/*
* @name SuperEvents
* Created By Chris grVulture Michaelides
* http://www.axxis.gr
* @copyright  Copyright (C) 2009,2010  AXXIS INTERNET SOLUTIONS / All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
//==============================================================================
defined('_JEXEC') or die();
//==============================================================================
// Return content of the given url
function cRemoteGetContent($url)
{
	if (!$url)
		return false;
	
	if (function_exists('curl_init'))
	{
		$ch			= curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		@curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		$response	= curl_exec($ch);
		curl_close($ch);
		return $response;
	}

	// CURL unavailable on this install
	return false;
}

function SG_VideoLinkHelper($content) {
	$pattern	= array();
	$videoLinks	= array();
	
	$pattern	= SG_GetVideoLinkPatterns();
	for( $i = 0; $i < count( $pattern ); $i++ )
	{
		//Match all video links
		preg_match_all($pattern[$i], $content, $match );
		if( $match )
		{
			$videoLinks[]	= $match[0];
		}
		
	}
	return $videoLinks;
}

function SG_GetVideoLinkPatterns()
{
	// Pattern for video providers
	$pattern	= array();
	$pattern[] = '/http\:\/\/vids.myspace.com\/index.cfm\?fuseaction\=([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;\/\?:@&]*)\=(\d{1,8})/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?youtube.com\/watch\?v\=([_-])?([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;\/\?:@&~=%-]*)/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?vimeo.com\/(hd#)?(\d*)/';
	$pattern[] = '/http\:\/\/(\w{2}\.)?video.yahoo.com\/watch\/(\d{1,8})\/(\d{1,8})/';
	$pattern[] = '/http\:\/\/video.google.(\w{2,4})\/videoplay\?docid=(-?\d{1,19})(&.*)?/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?revver.com\/video\/(\d{1,7})\/([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;\/\?:@&~=%-]*)/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?flickr.com\/photos\/(.*)\/(\d{1,10})/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?viddler.com\/explore\/(.*)\/videos\/(\d{1,3})\//';
	$pattern[] = '/http\:\/\/(\w{3}\.)?liveleak.com\/view\?i\=([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;\/\?:@&~=%-]*)/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?break.com\/index\/(.*?).html/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?dailymotion.com\/(.*)\/video\/(.*)/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?blip.tv\/file\/(\d{1,7})?([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;\/\?:@&~=%-]*)/';
	$pattern[] = '/http\:\/\/(\w{3}\.)?metacafe.com\/watch\/(\d{1,7})?([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;\/\?:@&~=%-]*)/';
	$pattern[] = '/http\:\/\/(media\.)?photobucket.com\/video\/([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;\/\?:@&~=%-\s]*)/';
	return $pattern;
}

/**
 *	Match video link in the wall
 *	
 *	@params	string	$content
 *	@return	string	$content with embeded code
 */ 
function SG_GetVideoEMBED($content, $videoWidth='425', $videoHeight='344')
{
  $url = $content;
  $videoLinks = SG_VideolinkHelper($content);	
	foreach($videoLinks as $videoLink)
	{
		// Replace the URL with the embedded code
		foreach($videoLink as $videoLinkUrl)
		{
      $videoObj = SG_GetVideoObject($videoLinkUrl);
      if ($videoObj) {
				$video_id		= $videoObj->getId();
				$videoPlayer	= $videoObj->getViewHTML($video_id, $videoWidth, $videoHeight);
				$content = str_replace( $videoLinkUrl, $videoPlayer, $content );
			}
		}
	}
	if ($content=='' || $content==$url) {
    // get embed from user video galleries
    try {
      $ch = curl_init($url);
      curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1); 
      curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 5);
      $data = curl_exec($ch);
      curl_close($ch);
      if (strstr($data,'not found')) $data="";
    } catch (Exception $e) {
      $data = @file_get_contents($url);
    }
    if ($data) {
      // Now check if embed code is there
      preg_match_all('/<link rel="video_src".*?href\s*=\s*["\'](.+?)["\']/im', $data, $images);
      /*         
      if (count($images[1])==0) {
        // Now check if it is in Open Graph
        if (strstr($data,'<meta property="og:type" content="movie" />')) {
          preg_match_all('/<meta property="og:url".*?content\s*=\s*["\'](.+?)["\']/im', $data, $images);
        }         
      }
      */
      if (count($images[1])>0) {
        foreach($images[1] as $image) {
          $image = str_replace('http://player.longtailvideo.com/player.swf?file=','',$image);
          $return = SG_GetVideoEMBED($image);
          if ($return=='' || $return==$image) {
            $return = '<embed src="http://player.longtailvideo.com/player.swf?file='.$image.'" type="application/x-shockwave-flash" allowfullscreen="true" allowScriptAccess="always" width="425" height="344" />';
          }
          return $return;
        }
      }
    } 
	}
	return $content;
}

function SG_GetVideoTitle($content)
{
  $videoObj = SG_GetVideoObject($content);
  if ($videoObj) {
		$video_title= $videoObj->getTitle();
	}
	return $video_title;
}

function SG_GetVideoDescription($content)
{
  $videoObj = SG_GetVideoObject($content);
  if ($videoObj) {
		$video_description = $videoObj->getDescription();
	}
	return $video_description;
}

function SG_GetVideoThumbnail($content)
{
  $video_thumb='';
  $videoLinks = SG_VideolinkHelper($content);	
	foreach($videoLinks as $videoLink)
	{
		// Replace the URL with the embedded code
		foreach($videoLink as $videoLinkUrl)
		{
      $videoObj = SG_GetVideoObject($videoLinkUrl);
      if ($videoObj) {
				$video_thumb = $videoObj->getThumbnail();
			}
		}
	}
	 if ($video_thumb=='') {
      $videoObj = SG_GetVideoObject($content);
      if ($videoObj) {
				$video_thumb = $videoObj->getThumbnail();
			}
  	}
	return $video_thumb;
}

function SG_GetVideoObject($videoLinkUrl)
{
	$parsedVideoLink	= parse_url($videoLinkUrl);
	preg_match('/(?P<domain>[a-z0-9][a-z0-9\-]{1,63}\.[a-z\.]{2,6})$/i', $parsedVideoLink['host'], $matches);
	$domain	= $matches['domain'];
	$videoObj = false;
	if (!empty($domain))
	{
		$provider		= explode('.', $domain);
		$providerName	= JString::strtolower($provider[0]);
		$libraryPath	= JPATH_COMPONENT . DS . 'libraries' . DS . 'videos' . DS . $providerName . '.php';
				
		if (file_exists($libraryPath)) {
      require_once($libraryPath);
		  $className		= 'SG_TableVideo' . JString::ucfirst($providerName);
		  $videoObj		= new $className();
		} else {
  		$libraryPath	= JPATH_COMPONENT . DS . 'libraries' . DS . 'videos' . DS . 'uservideogalleries' . '.php';
      require_once($libraryPath);
		  $className		= 'SG_TableVideoGalleries';
		  $videoObj		= new $className();
		}
	}
	if ($videoLinkUrl) {
  	$videoObj->init($videoLinkUrl);
  	if ($videoObj->isValid()) {
  	 return $videoObj;
  	} else
  	 echo '<script type="text/javascript">history.go(-1);</script>';
	} else {
	 echo '<script type="text/javascript">history.go(-1);</script>';
	}
}

function SG_GetVideoType($content) {
  $videoObj = SG_GetVideoObject($content);
  $videoObj->init($content);
  if ($videoObj->isValid()) {
    return $videoObj->getType();
  } else {
    return false;
  }
}

function SG_GetVideoFile($content) {
  $videoObj = SG_GetVideoObject($content);
  $videoObj->init($content);
  if (SG_GetVideoType($content)=='uservideogalleries') {
    return $videoObj->videofile;
  } else {
    return false;
  }
}