/***********************************************************************
* @name superevents v4.2.1.4
* Created By Chris grVulture Michaelides
* http://www.axxis.gr
* @copyright  Copyright (C) 2009,2010,2011  AXXIS INTERNET SOLUTIONS / All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
************************************************************************/
jQuery.noConflict();

jQuery.ajaxSetup ({
    // Disable caching of AJAX responses */
    cache: false
});

jQuery(document).ready(function(){
if (document.getElementById('grseconds')) {
(function($) {
  $.timeago = function(timestamp) {
    if (timestamp instanceof Date) return inWords(timestamp);
    else if (typeof timestamp == "string") return inWords($.timeago.parse(timestamp));
    else return inWords($.timeago.parse($(timestamp).attr("id")));
  };
  var $t = $.timeago;
 
  $.extend($.timeago, {
    settings: {
      refreshMillis: 60000,
      allowFuture: false,
      strings: {
        prefixAgo: null,
        prefixFromNow: null,
        suffixAgo: null,
        suffixFromNow: "from now",
        ago: null, // DEPRECATED, use suffixAgo
        fromNow: null, // DEPRECATED, use suffixFromNow
        seconds: document.getElementById('grseconds').value,
        minute: document.getElementById('minute').value,
        minutes: document.getElementById('before_days').value+"%d"+document.getElementById('minutes').value,
        hour: document.getElementById('hour').value,
        hours: document.getElementById('about').value+document.getElementById('before_days').value+"%d"+document.getElementById('hours').value,
        day: document.getElementById('day').value,
        days: document.getElementById('before_days').value+"%d"+document.getElementById('days').value,
        month: document.getElementById('month').value,
        months: document.getElementById('before_days').value+"%d"+document.getElementById('months').value,
        year: document.getElementById('year').value,
        years: document.getElementById('before_days').value+"%d"+document.getElementById('years').value
      }
    },
    inWords: function(distanceMillis) {
      var $l = this.settings.strings;
      var prefix = $l.prefixAgo;
      var suffix = $l.suffixAgo || $l.ago;
      if (this.settings.allowFuture) {
        if (distanceMillis < 0) {
          prefix = $l.prefixFromNow;
          suffix = $l.suffixFromNow || $l.fromNow;
        }
        distanceMillis = Math.abs(distanceMillis);
      }

      var seconds = distanceMillis / 1000;
      var minutes = seconds / 60;
      var hours = minutes / 60;
      var days = hours / 24;
      var years = days / 365;

      var words = seconds < 45 && substitute($l.seconds, Math.round(seconds)) ||
        seconds < 90 && substitute($l.minute, 1) ||
        minutes < 45 && substitute($l.minutes, Math.round(minutes)) ||
        minutes < 90 && substitute($l.hour, 1) ||
        hours < 24 && substitute($l.hours, Math.round(hours)) ||
        hours < 48 && substitute($l.day, 1) ||
        days < 30 && substitute($l.days, Math.floor(days)) ||
        days < 60 && substitute($l.month, 1) ||
        days < 365 && substitute($l.months, Math.floor(days / 30)) ||
        years < 2 && substitute($l.year, 1) ||
        substitute($l.years, Math.floor(years));

      return $.trim([prefix, words, suffix].join(" "));
    },
    parse: function(iso8601) {
      var s = $.trim(iso8601);
      s = s.replace(/-/,"/").replace(/-/,"/");
      s = s.replace(/T/," ").replace(/Z/," UTC");
      s = s.replace(/([\+-]\d\d)\:?(\d\d)/," $1$2"); // -04:00 -> -0400
      return new Date(s);
    }
  });

  $.fn.timeago = function() {
    var self = this;
    self.each(refresh);

    var $s = $t.settings;
    if ($s.refreshMillis > 0) {
      setInterval(function() { self.each(refresh); }, $s.refreshMillis);
    }
    return self;
  };

  function refresh() {
    var date = $t.parse(this.id);
    if (!isNaN(date)) {
      $(this).text(inWords(date));
    }
    return this;
  }

  function inWords(date) {
    return $t.inWords(distance(date));
  }

  function distance(date) {
    return (new Date().getTime() - date.getTime());
  }

  function substitute(stringOrFunction, value) {
    var string = $.isFunction(stringOrFunction) ? stringOrFunction(value) : stringOrFunction;
    return string.replace(/%d/i, value);
  }

  // fix for IE6 suckage
  if ($.browser.msie && $.browser.version < 7.0) {
    document.createElement('abbr');
  }
})(jQuery);
}

  function feedUpdate(){
       var url = '/components/com_superevents/helpers/feedupdate.php';
       var pars = '?comment-name='+escape(jQuery('comment-name'));
       var target = 'hidden-div';
       jQuery('#hidden-div').load(url+pars);
  }

	function commentUpdate(){
	 try {
     var enable_wall = document.getElementById('enable_wall').value;
     var dirname = document.getElementById('dirname').value;
     var url = dirname+'/components/com_superevents/helpers/commentupdate.php';

        jQuery.get(url, {
           updatedata: document.getElementById('updatedata').value,
           appendarray: encodeURIComponent(document.getElementById('appendarray').value),
           pageopened: encodeURIComponent(document.getElementById('pageopened').value),
           table: encodeURIComponent(document.getElementById('table').value)
                          },
          function(data){
               var already = document.getElementById('hidden-div').value;           
                var appendtocomment = unescape(decodeURIComponent(data));
              if (already != appendtocomment) {
               document.getElementById('hidden-div').value = appendtocomment;               
                var data = appendtocomment.split('-epomeno-');
                var comment = data[0].split('-sxolia-');
                var actid = data[1].split(','); 
                var newtime = data[2];
                var commentsid = data[3].split(','); 
                if (newtime!='') {document.getElementById('pageopened').value = newtime;}
                for(i=0;i<actid.length;i++) {
                  if (enable_wall==1) {
                    jQuery('#commentsdiv-'+actid[i]).prepend(comment[i]); //alert(commentsid[i]);
                  } else {
                    jQuery('#commentsdiv-'+actid[i]).append(comment[i]); //alert(commentsid[i]);
                  }
                    if (commentsid!='') jQuery('#' + commentsid[i]).fadeIn('slow');
                }
                jQuery('span[class*=timeago]').timeago();
              }
                setTimeout(commentUpdate, 15000);
          });
    } catch(err) {
    }
  }

  function pending_transactions() {
    try {
      var grsite = document.getElementById('grsite').value;
    } catch(err) {
      var grsite = 'http://'+window.location.hostname+'/';
    }
      url = grsite+'components/com_superevents/helpers/transaction_pending.php';
      jQuery.post(url, {
          myid : document.getElementById('myid').value,
          groupid: document.getElementById('groupid').value
        },
          function(data){
            if (data=='OK') {
              return true;
            } else {
              return false;
            }
          }
        );
    return true;
  }

  function repeat_events() {
    try {
      var grsite = document.getElementById('grsite').value;
    } catch(err) {
      var grsite = 'http://'+window.location.hostname+'/';
    }
      url = grsite+'index.php?option=com_superevents&task=repeat&tmpl=component';
      jQuery.post(url, {
          option : 'com_superevents',
          task : 'repeat',
          tmpl : 'component',
        },
          function(data){
            rseconds = (document.getElementById('repeat_seconds').value)+'000';
            setTimeout(repeat_events, rseconds);
          }
        );
    return true;
  }

//call custom functions
	//- - - - - - - - - - - -
	setTimeout(commentUpdate, 15000);
	//- - - - - - - - - - - -
	repeat_events();

	if (document.getElementById('groupid')) setTimeout(pending_transactions, 2000);

  if (document.getElementById('grseconds')) jQuery('span[class*=timeago]').timeago();

});
// END OF LOADING PAGE FUNCTIONS
// ***************************************************************************************

  function get_commentid(id){
      var enable_wall = document.getElementById('enable_wall').value;
      var grsite  = document.getElementById('grsite').value;
      var dirname = document.getElementById('dirname').value;
      var commentid = id;
      var superaddon_Login = document.getElementById('superaddon_Login').value;
      var superaddon_Write = document.getElementById('superaddon_Write').value;
      var url1 = dirname+'/components/com_superevents/helpers/preparecomment.php';
      var url2 = dirname+'/components/com_superevents/helpers/addcomment.php';
      var commentname = encodeURIComponent(document.getElementById('comment-name'+commentid).value);
  
      var field = 'mydiv-'+commentid;
      var button= 'buttondiv-'+commentid;
      var inputdiv = 'comment-name'+commentid;
      var login = 'login'+commentid;
      
  // if no comment yet...
      if (commentname=='') {
        var browser=navigator.appName;
        var commentshow = document.getElementById('commentshow-'+commentid).value;
        jQuery('#'+field).slideUp('slow');
        //jQuery('#'+button).fadeOut('slow'); // for some reason it doesn't work in Google Chrome
        document.getElementById(button).style.display = "none"; // let's go for this instead
        document.getElementById(inputdiv).style.fontSize = "10px";
        document.getElementById(inputdiv).style.color = "#999999";
        document.getElementById(inputdiv).value = superaddon_Write;
        //alert (document.activeElement.focus);
        if (commentshow=="block") {
          jQuery('#'+inputdiv).slideDown('slow');
          if (browser=="Microsoft Internet Explorer") document.getElementById('commentshow-'+commentid).value = "none";
        } else {
          jQuery('#'+inputdiv).slideUp('slow');
          if (browser=="Microsoft Internet Explorer") document.getElementById('commentshow-'+commentid).value = "block";
        }
      } else {
        var pressed = document.getElementById('button-pressed'+commentid).value;
  
  //if button clicked...      
        if (pressed=='PRESSED') {
  // process the time display...
          var currentTime = new Date();
          var hours = currentTime.getHours();
          var minutes = currentTime.getMinutes();
          var suffix = "am";
          if (hours >= 12) {
            suffix = "pm";
            hours = hours - 12;
          }
          if (hours == 0) {
            hours = 12;
          }
          if (minutes < 10) minutes = "0" + minutes;
        
          var minas = getDateStrWithDOW();
          
  // prepare elements...
          document.getElementById('button-pressed'+commentid).value = "button-pressed"+commentid;    

          //alert(commentname);
  // prepare the text...
        jQuery.post(url1, {
            commentname : commentname
                          },
          function(data){
                  //alert(data);
                var preparedcomment = data;
          // make the AJAX call...
                jQuery.post(url2, {
                    myid : document.getElementById('myid').value,
                    commentid : commentid,
                    commentname : preparedcomment,
                    table: encodeURIComponent(document.getElementById('table').value)
                          },
          function(data){
                  // append my comment to the comments div
                          var mycommenter = decodeURIComponent(document.getElementById('append-input'+commentid).value);
                          var superaddon_Write = document.getElementById('superaddon_Write').value;
                          now = new Date();
                          now = now.format("isoDateTime");
                          if (enable_wall==1) {
                            jQuery('#commentsdiv-'+commentid).prepend("<div class=\"comments_div\" id=\""+data+"\" style=\"display:none;\">"+mycommenter+" <span class=\"supergroup_small_text\"><span class=\"timeago\" id=\""+now+"\">"+hours+":"+minutes+suffix+" "+minas+"</span></span><br />"+stripslashes(decodeURIComponent(preparedcomment))+"<a style=\"float:right;\" href=\"javascript:delete_comment("+data+")\" title=\"remove this comment\"><img style=\"padding-left:3px;\" src=\""+dirname+"/components/com_superevents/images/cancel.png\" width=\"10\" /></a></td></tr></table></div>");
                          } else {
                            jQuery('#commentsdiv-'+commentid).append("<div class=\"comments_div\" id=\""+data+"\" style=\"display:none;\">"+mycommenter+" <span class=\"supergroup_small_text\"><span class=\"timeago\" id=\""+now+"\">"+hours+":"+minutes+suffix+" "+minas+"</span></span><br />"+stripslashes(decodeURIComponent(preparedcomment))+"<a style=\"float:right;\" href=\"javascript:delete_comment("+data+")\" title=\"remove this comment\"><img style=\"padding-left:3px;\" src=\""+dirname+"/components/com_superevents/images/cancel.png\" width=\"10\" /></a></td></tr></table></div>");
                          }
                          jQuery('#'+data).fadeIn(2500);
                  // Re-initialize the comment-box for next comment...
                          jQuery('#'+field).slideUp('slow');
                          jQuery('#'+button).slideUp('slow');
                          document.getElementById(inputdiv).style.fontSize = "10px";
                          document.getElementById(inputdiv).style.color = "#999999";
                          document.getElementById(inputdiv).value = superaddon_Write;
                          jQuery('#'+inputdiv).slideDown('slow');
                  // post to JS activity stream
                          jQuery.post(grsite+'index.php', {
                            option: 'com_superevents',
                            task: 'js_new_comment',
                            commentid : commentid,
                            commentname : preparedcomment,
                            table: encodeURIComponent(document.getElementById('table').value),
                            id: document.getElementById('groupid').value
                          }, function(data){}
                          );
                  // restart the time updater
                        }
                      );
                }
          );
                      jQuery('span[class*=timeago]').timeago();

        }
      }
  }

  function showfield(id){
      var browser=navigator.appName;
      var commentid = id;
      var superaddon_Login = document.getElementById('superaddon_Login').value;
      var superaddon_Write = document.getElementById('superaddon_Write').value;
      var commentname = document.getElementById('comment-name'+commentid).value;
      var field = 'mydiv-'+commentid;
      var button= 'buttondiv-'+commentid;
      var inputdiv = 'comment-name'+commentid;
      var login = 'login'+commentid;
      if (document.getElementById(inputdiv).style.display=='none') {
        if (browser=="Microsoft Internet Explorer") document.getElementById('commentshow-'+commentid).value = "block";
        if (commentname != superaddon_Login) {
          jQuery('#'+field).slideDown('slow');
          jQuery('#'+button).slideDown('slow');
          document.getElementById(inputdiv).style.fontSize = "14px";
          document.getElementById(inputdiv).style.color = "#000000";
          document.getElementById(inputdiv).value = "";
          jQuery('#'+inputdiv).slideDown('slow');
          var xx = document.getElementById(inputdiv).focus();
        } else {
          jQuery('#'+login).slideDown('slow');
    // calling an anonymous function that calls the function you need with your desired parameters! SWEEEET, but head-banger to figure out!
        	setTimeout(function(){get_commentid(commentid)}, 4000);
        }
      } else {
        if (commentname == superaddon_Write) {
          if (browser=="Microsoft Internet Explorer") document.getElementById('commentshow-'+commentid).value = "block";
          jQuery('#'+field).slideDown('slow');
          jQuery('#'+button).slideDown('slow');
          document.getElementById(inputdiv).style.fontSize = "14px";
          document.getElementById(inputdiv).style.color = "#000000";
          document.getElementById(inputdiv).value = "";
          jQuery('#'+inputdiv).slideDown('slow');
          var xx = document.getElementById(inputdiv).focus();
        }
      }
  }
  
  function showmore(id){
      var commentid = id;
      var more = 'more'+commentid;
      var show = 'show'+commentid;
      var hide = 'hidecomments'+commentid;
      jQuery('#'+show).fadeOut('slow');
      jQuery('#'+more).slideDown('slow');
      jQuery('#'+hide).fadeIn('slow');
  }
  function hidemore(id){
      var commentid = id;
      var more = 'more'+commentid;
      var show = 'show'+commentid;
      var hide = 'hidecomments'+commentid;
      jQuery('#'+hide).fadeOut('slow');
      jQuery('#'+more).fadeOut('slow');
      jQuery('#'+show).fadeIn(1500);
  }
  
  function delete_comment(id){
      var dirname = document.getElementById('dirname').value;
      var commentid = id;
      var url = dirname+'/components/com_superevents/helpers/deletecomment.php';
        jQuery.get(url, {
          commentid : commentid,
          table: encodeURIComponent(document.getElementById('table').value)
        },
          function(data){
                  // Re-initialize the comment-box for next comment...
                          jQuery('#'+commentid).fadeOut('slow');
                }
          );
  }
  
  function get_ready(id){
      var commentid = id;
      var field = 'mydiv-'+commentid;
          jQuery('#'+field).slideUp('slow');
      var imagediv = 'imagediv-'+commentid;
      var inputdiv = 'button-pressed'+commentid;
      document.getElementById(inputdiv).value = "PRESSED";
      get_commentid(commentid);
  }

function showfriends(event) {
  var grsite = document.getElementById('grsite').value;
  if (document.getElementById('friends_table').style.display=='none') {
    switch_display_friends_loading();
    document.getElementById('friendloading').innerHTML = '<img src="'+grsite+'components/com_superevents/images/indicator_blue_large.gif" height="12"/>';
    jQuery('#friends_table').slideDown('slow');
  } else {
    jQuery('#friends_table').slideUp('slow');
  }  
}

function fembedimage() {
  if (document.getElementById('imageformdiv').style.display == "block") document.getElementById('imageformdiv').style.display = "none";
  else document.getElementById('imageformdiv').style.display = "block"; 
}

function send_image(theFormName) {
    var image = encodeURIComponent(document.getElementById('imageURL').value);
    var grsite = document.getElementById('grsite').value;
    url = grsite+'components/com_superevents/helpers/embedprocess.php';
    jQuery.post(url, {
        imageURL : image
      },
        function(data){
          //alert(data);
          document.getElementById('imagediv').innerHTML = data;
          document.getElementById('attach_it').style.display = 'block';
          document.getElementById('imageformdiv').style.display = 'none';
        }
    );
}

function display_response(theDiv) {
    //alert(xmlHttp.responseText);
}

function delete_news(newsid) {
    var grsite = document.getElementById('grsite').value;
    document.getElementById('news'+newsid).innerHTML = '<img src="'+grsite+'components/com_superevents/images/indicator_blue_large.gif" />';
    url = grsite+'components/com_superevents/helpers/deletenews.php';
    jQuery.post(url, {
        news : newsid
      },
        function(data){
          document.getElementById('news'+newsid).style.display='none';
        }
    );
}

function store_userdate(theDate) {
	var rightNow = new Date();
	var jan1 = new Date(rightNow.getFullYear(), 0, 1, 0, 0, 0, 0);  // jan 1st
	var june1 = new Date(rightNow.getFullYear(), 5, 1, 0, 0, 0, 0); // june 1st
	var temp = jan1.toGMTString();
	var jan2 = new Date(temp.substring(0, temp.lastIndexOf(" ")-1));
	temp = june1.toGMTString();
	var june2 = new Date(temp.substring(0, temp.lastIndexOf(" ")-1));
	var std_time_offset = (jan1 - jan2) / (1000 * 60 * 60);
	var daylight_time_offset = (june1 - june2) / (1000 * 60 * 60);
	var dst;
	if (std_time_offset == daylight_time_offset) {
		dst = "0"; // daylight savings time is NOT observed
	} else {
		// positive is southern, negative is northern hemisphere
		var hemisphere = std_time_offset - daylight_time_offset;
		if (hemisphere >= 0)
			std_time_offset = daylight_time_offset;
		dst = "1"; // daylight savings time is observed
	}
	//alert(std_time_offset);
  try {
    var grsite = document.getElementById('grsite').value;
  } catch(err) {
    var grsite = 'http://'+window.location.hostname+'/';
  }
    url = grsite+'components/com_superevents/helpers/store_userdate.php';
    jQuery.post(url, {
        dst: dst,
        offset : std_time_offset,
        date : theDate
      },
        function(data) {
        }
    );
}
// =============================================================================
  function reply_report_comment(id){
      var grsite  = document.getElementById('grsite').value;
      var dirname = document.getElementById('dirname').value;
      var action  = document.getElementById('reply_report_action'+id).value;
      var commentid = id;
      var reported = document.getElementById('reported'+id).value;
      var pagecheck= '';
      // if reported comment is 0, then user has reported the whole page. Distinquish it, to check it later in the admin panel
      if (reported == 'superevents_wrapper') {
        reported = id;
        pagecheck= '_0';
      }
      if (action=='reply') {
        var commentname = encodeURIComponent(document.getElementById('reply_report_textarea'+id).value);
        var url1 = dirname+'/components/com_superevents/helpers/preparecomment.php';
        var url2 = dirname+'/components/com_superevents/helpers/addcomment.php';
        jQuery.post(url1, {
            commentname : commentname
                          },
          function(data){
                  //alert(data);
                var preparedcomment = data;
          // make the AJAX call...
                jQuery.post(url2, {
                    myid : document.getElementById('myid').value,
                    commentid : commentid,
                    commentname : preparedcomment,
                    table: encodeURIComponent(document.getElementById('table').value)
                          },
          function(data){
                  // Re-initialize the comment-box for next comment...
                  jQuery('#reply_report'+id).fadeOut('slow');
                  // post to JS activity stream
                          jQuery.post(grsite+'index.php', {
                            option: 'com_superevents',
                            task: 'js_new_comment',
                            commentid : commentid,
                            commentname : preparedcomment,
                            table: encodeURIComponent(document.getElementById('table').value),
                            id: document.getElementById('groupid').value
                          }, function(data){}
                          );
                  // refresh the page
                  location.reload(true);
                        }
                      );
                }
          );
      } else {
        var url = dirname+'/components/com_superevents/helpers/report.php';
        var commentname = encodeURIComponent(document.getElementById('reply_report_textarea'+id).value);
        jQuery.post(url, {
            table: encodeURIComponent(document.getElementById('table').value+pagecheck),
            link: encodeURIComponent(window.location.href),
            commentname : commentname,
            myid : document.getElementById('myid').value,
            commentid : reported
                          },
          function(data){
                  // Re-initialize the comment-box for next comment...
                  document.getElementById('reply_report_textarea'+id).value='';
                  jQuery('#reply_report'+id).fadeOut('slow');
                }
          );
      }
  }

  function like_comment(id){
      var dirname = document.getElementById('dirname').value;
      var commentid = id;
      var totallikers = document.getElementById('totallikers'+commentid).innerHTML;
      totallikers ++;
      var url = dirname+'/components/com_superevents/helpers/like.php';
        jQuery.get(url, {
          table: encodeURIComponent(document.getElementById('table').value),
          commentid : commentid,
          myid : document.getElementById('myid').value
        },
          function(data){
                  // Re-initialize the button for next like...
                  document.getElementById('likebutton'+commentid).src=dirname+'/components/com_superevents/images/thumbs-up-green.png';
                  if (data!="already") document.getElementById('totallikers'+commentid).innerHTML = totallikers;        
                  document.getElementById('totallikers'+commentid).style.display = "inline";
                  document.getElementById('likebutton'+commentid).onmouseover = "";
                  document.getElementById('likebutton'+commentid).onmouseout = "";
                  document.getElementById('likebutton'+commentid).onclick = "";
                }
          );
  }

  function unlike_comment(id){
      var dirname = document.getElementById('dirname').value;
      var commentid = id;
      var totallikers = document.getElementById('totallikers'+commentid).innerHTML;
      totallikers --;
      var url = dirname+'/components/com_superevents/helpers/unlike.php';
        jQuery.get(url, {
          table: encodeURIComponent(document.getElementById('table').value),
          commentid : commentid,
          myid : document.getElementById('myid').value
        },
          function(data){
                  // Re-initialize the button for next like...
                  document.getElementById('likebutton'+commentid).src=dirname+'/components/com_superevents/images/thumbs-up-default.png';
                  if (data!="already") document.getElementById('totallikers'+commentid).innerHTML = totallikers;        
                  document.getElementById('likebutton'+commentid).onmouseover = "";
                  document.getElementById('likebutton'+commentid).onmouseout = "";
                  document.getElementById('likebutton'+commentid).onclick = "";
                }
          );
  }

  function prepare_reply(commentid,id,commentername,string,action){
    if (action=='report') {
      document.getElementById('reply_report_titlespan'+id).innerHTML = string;
    	document.getElementById('reply_report'+id).style.left = (document.getElementById(commentid).offsetLeft + 90)+'px';
  	  document.getElementById('reply_report'+id).style.top  = (document.getElementById(commentid).offsetTop + 45)+'px';
      jQuery('#reply_report'+id).fadeIn('slow');
      document.getElementById('reply_report_textarea'+id).value='';
      document.getElementById('reply_report_action'+id).value=action;
      document.getElementById('reported'+id).value=commentid;
    } else {
      showfield(id);
      document.getElementById('comment-name'+id).value="@"+commentername+': ';
    }
  }

  function who_likes_comment(id){
  	document.getElementById('likers'+id).style.left = (document.getElementById(id).offsetLeft + 90)+'px';
  	document.getElementById('likers'+id).style.top  = (document.getElementById(id).offsetTop)+'px';
    jQuery('#likers'+id).fadeIn('slow');
  }

//------------- GOOGLE MAPS ----------------------------------------------------
function showmap(event) {
  	document.getElementById('floatwrapper').style.left = (event.clientX + 3)+'px';
  	document.getElementById('floatwrapper').style.top  = (event.clientY + 3)+'px';
    jQuery('#floatwrapper').fadeIn('slow');
}
function show_map_locator(event) {
  	//document.getElementById('map').style.left = (event.clientX + 3)+'px';
  	//document.getElementById('map').style.top  = (event.clientY + 3)+'px';
    jQuery('#floatwrapper').fadeOut('slow');
    jQuery('#map').fadeIn('slow');
}
//------------- END GOOGLE MAPS ------------------------------------------------

function validate_username() {
  if (document.getElementById('username_warning').style.display=='block') {
    document.getElementById('username_warning').style.display='none';
  } else {
    var username = encodeURIComponent(document.getElementById('grusername').value);
    try {
      var grsite = document.getElementById('grsite').value;
    } catch(err) {
      var grsite = 'http://'+window.location.hostname+'/';
    }
    url = grsite+'components/com_superevents/helpers/check_username.php';
    jQuery.post(url, {
        username : username
      },
        function(data){
          if (data!='OK') {
            document.getElementById('username_warning').style.display='block';
            //document.getElementById('username').focus();
          }
        }
    );
  }
}

function validate_email() {
  if (document.getElementById('email_warning').style.display=='block') {
    document.getElementById('email_warning').style.display='none';
  } else {
    var email = encodeURIComponent(document.getElementById('gremail').value);
    try {
      var grsite = document.getElementById('grsite').value;
    } catch(err) {
      var grsite = 'http://'+window.location.hostname+'/';
    }
    url = grsite+'components/com_superevents/helpers/check_email.php';
    jQuery.post(url, {
        email : email
      },
        function(data){
          if (data!='OK') {
            document.getElementById('email_warning').style.display='block';
            //document.getElementById('email').focus();
          }
        }
    );
  }
}

function in_progress(myid,groupid) {
  try {
    var grsite = document.getElementById('grsite').value;
  } catch(err) {
    var grsite = 'http://'+window.location.hostname+'/';
  }
    url = grsite+'components/com_superevents/helpers/transaction_in_progress.php';
    jQuery.post(url, {
        myid : myid,
        groupid: groupid
      },
        function(data){
          if (data=='OK') {
            document.paypal.submit();
          } else {
            return false;
          }
        }
      );
  return true;
}
