<?php
/*
* @name SuperGroups 2.5
* Created By Chris grVulture Michaelides
* http://www.axxis.gr
* @copyright  Copyright (C) 2009,2010  AXXIS INTERNET SOLUTIONS / All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
//==============================================================================
defined('_JEXEC') or die();
//==============================================================================
/**

 * Class to manipulate data from Break

 * 	 	

 * @access	public  	 

 */

class SG_TableVideoBreak

{

	var $xmlContent = null;

	var $url = '';

	

	/**

	 * Return feedUrl of the video

	 */

	function getFeedUrl()

	{

		return 'http://www.break.com/' . $this->getId();

	}

	

	function init($url)

	{

		$this->url = $url;

		$this->xmlContent	= cRemoteGetContent($this->getFeedUrl());
	}

	

	/*

	 * Return true if successfully connect to remote video provider

	 * and the video is valid

	 */	 

	function isValid()

	{

		// Connect and get the remote video

		$this->xmlContent	= cRemoteGetContent($this->getFeedUrl());

		$videoId = $this->getId();

		if (empty($videoId))

		{

			$this->setError	= JText::_('CC INVALID VIDEO ID');

			return false;

		}

		if($this->xmlContent == FALSE)

		{

			$this->setError	= JText::_('CC ERROR FETCHING VIDEO');

			return false;

		}

		

		return true;			

	}	

	

	/**

	 * Extract Break video id from the video url submitted by the user

	 * 	 	

	 * @access	public

	 * @param	video url

	 * @return videoid	 

	 */

	function getId()

	{

		$code	= '';

				

		//check for embed code format

		$pos_u = strpos($this->url, "break.com/");



		////TODO: User regular expression instead

		if ($pos_u === false) {

			return null;

		} else if ($pos_u) {

			$pos_u_start = $pos_u;



			$code = substr($this->url, $pos_u_start+10);

			$code = strip_tags($code );

		}

						

		return $code;

	}

	

	

	/**

	 * Return the video provider's name

	 * 

	 */

	function getType()

	{

		return 'break';

	}

	

	function getTitle()

	{

		$title = '';		

		// Store video title

		$pattern =  "'<meta name=\"embed_video_title\" id=\"vid_title\" content=\"(.*?)\"( \/)?(>)'s";

		preg_match_all($pattern, $this->xmlContent, $matches);

		if($matches)

		{

			$title = $matches[1][0];

		}

		

		return $title;

	}

	

	function getDescription()

	{

		$description = '';

		// Store description

		$pattern =  "'<meta name=\"embed_video_description\" id=\"vid_desc\" content=\"(.*?)\"( \/)?(>)'s";

		preg_match_all($pattern, $this->xmlContent, $matches);

		if($matches)

		{

			$description = $matches[1][0];

		}

		

		return $description;

	}

	

	function getDuration()

	{			

		return 0;

	}

	

	/**

	 * Get video's thumbnail

	 * 

	 * @access 	public

	 * @param 	videoid

	 * @return url

	 */

	function getThumbnail()

	{

		$thumbnail = '';

		// Store thumbnail

		$pattern =  "'<meta name=\"embed_video_thumb_url\" content=\"(.*?)\"( \/)?(>)'s";

		preg_match_all($pattern, $this->xmlContent, $matches);

		if($matches)

		{

			$thumbnail = $matches[1][0];

		}

		

		return $thumbnail;

	}

	

	/**

	 * 

	 * 

	 * @return $embedvideo specific embeded code to play the video

	 */

	function getViewHTML($videoId, $videoWidth, $videoHeight)

	{

 		if (!$videoId)

		{

			$videoId	= $this->videoId;

		}

		$remoteFile	= 'http://www.break.com/'.$videoId;

		$xmlContent = cRemoteGetContent($remoteFile);

 		

		$pattern =  "'<meta name=\"embed_video_url\" content=\"(.*?)\"( /)?(>)'s";

		preg_match_all($pattern, $xmlContent, $matches);

		if($matches)

		{

				$videoUrl = $matches[1][0];

		}

		

		return "<embed src=\"".$videoUrl."\" width=\"".$videoWidth."\" height=\"".$videoHeight."\" wmode=\"transparent\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" type=\"application/x-shockwave-flash\" allowFullScreen=\"true\"> </embed>";

	}	

}

