<?php
/*
* @name SuperGroups 2.5
* Created By Chris grVulture Michaelides
* http://www.axxis.gr
* @copyright  Copyright (C) 2009,2010  AXXIS INTERNET SOLUTIONS / All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
//==============================================================================
defined('_JEXEC') or die();
//==============================================================================
/**

 * Class to manipulate data from Photobucket

 * 	 	

 * @access	public  	 

 */

class SG_TableVideoPhotobucket

{

	var $xmlContent = null;

	var $url		= '';

	var $videoId	= '';

	/**

	 * Return feedUrl of the video

	 */

	function getFeedUrl()

	{

		return 'http://media.photobucket.com/video/'.$this->videoId;

	}

	

	function init($url)

	{

		$this->url = $url;

		$this->videoId 	= $this->getId();

		$this->xmlContent	= cRemoteGetContent($this->getFeedUrl());
	}

	

	/*

	 * Return true if successfully connect to remote video provider

	 * and the video is valid

	 */	

	function isValid()

	{

		// Connect and get the remote video

		$this->xmlContent = cRemoteGetContent($this->getFeedUrl());

		

		if (empty($this->videoId))

		{

			$this->setError	= JText::_('CC INVALID VIDEO ID');

			return false;

		}

		if($this->xmlContent == false)

		{

			$this->setError	= JText::_('CC ERROR FETCHING VIDEO');

			return false;

		}



		return true;

	}	

	

	/**

	 * Extract video id from the video url submitted by the user

	 * 	 	

	 * @access	public

	 * @param	video url

	 * @return videoid	 

	 */

	function getId()

	{			

		//check for embed code format  

		$pos_u = strpos($this->url, "video/");	



		////TODO: User regular expression instead

		if ($pos_u === false) {

			return null;

		} else if ($pos_u) {

			$pos_u_start = $pos_u + 6;



			$code = substr($this->url, $pos_u_start);

			$code = strip_tags($code );

		}								 

		return $code;

	}

	

	/**

	 * Return the video provider's name

	 * 

	 */

	function getType()

	{

		return 'photobucket';

	}

	

	function getTitle()

	{

		$title	= '';

		

		// Get title

		$pattern =  "'<h2 id=\"mediaTitle\">(.*?)<\/h2>'s";

		preg_match_all($pattern, $this->xmlContent, $matches);

		if($matches)

		{

			$title = $matches[1][0];

		}var_dump($title);exit;



		return $title;

		

	}

	

	function getDescription()

	{

		$description	= '';

		

		// Get description

		$pattern =  "'<meta name=\"description\" content=\"(.*?)\" \/>'s";

		preg_match_all($pattern, $this->xmlContent, $matches);

		if($matches)

		{

			$description = trim(strip_tags($matches[1][0]));

		}

		

		return $description;

	}

	

	function getDuration()

	{

		return 0;

	}

	

	/**

	 * 

	 * @param $videoId

	 * @return unknown_type

	 */

	function getThumbnail()

	{

		$thumbnail	= '';



		// Get thumbnail 	 

		$pattern =  "'<link rel=\"image_src\" href=\"(.*?)\" \/>'s";

		preg_match_all($pattern, $this->xmlContent, $matches);

		if($matches)

		{

			$thumbnail = $matches[1][0];

		}

		

		return $thumbnail;

	}



	/**

	 * 

	 * 

	 * @return $embedvideo specific embeded code to play the video

	 */

	function getViewHTML($videoId, $videoWidth, $videoHeight)

	{

		if (!$videoId)

		{

			$videoId	= $this->videoId;

		}

		$file 	= 'http://media.photobucket.com/video/'.JString::str_ireplace( " ", "%20", $videoId );

		$xmlContent = cRemoteGetContent($file);

		if ($xmlContent==FALSE)

		{

			return false;

		}

		$pattern =  "'<link rel=\"video_src\" href=\"(.*?)\" \/>'s";

		preg_match_all($pattern, $xmlContent, $matches);

		if($matches)

		{

			$videoUrl= rawurldecode($matches[1][0]);

		}

		$embedCode = '<embed width="'.$videoWidth.'" height="'.$videoHeight.'" type="application/x-shockwave-flash" wmode="transparent" src="'.$videoUrl.'">';

		return $embedCode;

	}



}

