<?php
/*
* @name SuperGroups 2.5
* Created By Chris grVulture Michaelides
* http://www.axxis.gr
* @copyright  Copyright (C) 2009,2010  AXXIS INTERNET SOLUTIONS / All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
//==============================================================================
defined('_JEXEC') or die();
//==============================================================================
/**

 * Class to manipulate data from Truveo

 * 	 	

 * @access	public  	 

 */

class SG_TableVideoTruveo

{

	var $xmlContent = null;

	var $url 		= '';

	var $videoId	= '';

	

	/**

	 * Return feedUrl of the video

	 */

	function getFeedUrl()

	{

		$videoId = explode("/",$this->videoId);

		return 'http://xml.truveo.com/apiv3?appid=1x1jhj64466mi12ia&method=truveo.videos.getVideos&query='.$videoId[2];

	}

	

	function init($url)

	{

		$this->url 		= $url;

		$this->videoId 	= $this->getId();

		$this->xmlContent	= cRemoteGetContent($this->getFeedUrl());
	}

	

	/*

	 * Return true if successfully connect to remote video provider

	 * and the video is valid

	 */	 

	function isValid()

	{

		// Connect and get the remote video

		

		$xmlContent = cRemoteGetContent($this->getFeedUrl());

		

		if (empty($this->videoId))

		{

			$this->setError	= JText::_('CC INVALID VIDEO ID');

			return false;

		}

		if($xmlContent == false)

		{

			$this->setError	= JText::_('CC ERROR FETCHING VIDEO');

			return false;

		}		

		

		$parser = JFactory::getXMLParser('Simple');

		$parser->loadString($xmlContent);

		$videoElement = $parser->document;

		

		// Get Video Title

		$element = $videoElement->getElementByPath('videoset/video/title');			

		$this->title = $element->data();

		// Get Video description

		$element = $videoElement->getElementByPath('videoset/video/description');

		$this->description = $element ? $element->data() : '';

		// Get Video duration

		if($videoElement->getElementByPath('videoset/video/runtime')==true){   

			$element = $videoElement->getElementByPath('videoset/video/runtime');

			$this->duration = $element->data();	

		}

		// Get Video thumbnail

		$element = $videoElement->getElementByPath('videoset/video/thumbnailurl');

		$this->thumbnail = $element->data();



		return true;

	}

	

	/**

	 * Extract video id from the video url submitted by the user

	 * 	 	

	 * @access	public

	 * @param	video url

	 * @return videoid	 

	 */

	function getId()

	{

		$code	= '';

					

		//check for embed code format  

		$pos_u = strpos($this->url, "truveo.com/");	



		////TODO: User regular expression instead

		if ($pos_u === false) {

			return null;

		} else if ($pos_u) {

			$pos_u_start = $pos_u + 11;



			$code = substr($this->url, $pos_u_start);

			$code = strip_tags($code );										 	

		}							

			 

		return $code;

	}

	

	

	/**

	 * Return the video provider's name

	 * 

	 */

	function getType()

	{

		return 'truveo';

	}

	

	function getTitle()

	{

		return $this->title;

	}

	

	function getDescription()

	{

		return $this->description;

	}

	

	function getDuration()

	{

		return $this->duration;

	}

	

	function getThumbnail()

	{

		return $this->thumbnail;

	}

	

	/**

	 * 

	 * 

	 * @return $embedvideo specific embeded code to play the video

	 */

	function getViewHTML($videoId, $videoWidth, $videoHeight)

	{

		if (!$videoId)

		{

			$videoId	= $this->videoId;

		}

		$videoId	= explode("/",$videoId);

		$xmlContent	= cRemoteGetContent('http://xml.truveo.com/apiv3?appid=1x1jhj64466mi12ia&method=truveo.videos.getVideos&query='.$videoId[2]);

		$parser		= JFactory::getXMLParser('Simple');



		$parser->loadString($xmlContent);

		$videoElement = $parser->document;

		

		//get Video embed code

		$element	= $videoElement->getElementByPath('videoset/video/videoresultembedtag');	

		$embedTag	= $element->data();	



		$pattern	=  "'src=\"(.*?)\"'s";		 

		preg_match_all($pattern, $embedTag, $matches);

		if($matches)

		{

			$flashUrl = ' src="'.rawurldecode($matches[1][0]).'" ';

			$src = $matches[1][0];

		}

// 		$pattern	=  "'FlashVars=\'(.*?)\''s";

// 		$pattern	= '';

// 		preg_match_all($pattern, $embedTag, $matches);

// 		if(!empty($matches))

// 		{

// 			echo JUtility::dump($matches);

// 			echo count($matches);

// 			exit;

// 			$flashVar = ' FlashVars=\''.rawurldecode($matches[1][0]).'\' ';

// 		}

//		$embedCode	= "<embed ".$flashUrl.$flashVar." allowFullScreen='true' width='".$videoWidth."' height='".$videoHeight."' type='application/x-shockwave-flash' pluginspage='http://www.macromedia.com/go/getflashplayer' allowScriptAccess='always'></embed>";

		$embedCode	= "<embed flashvars='fs=1' allowfullscreen='true' src='$src' type='application/x-shockwave-flash' width='$videoWidth' height='$videoHeight' wmode='transparent'></embed>";

		return $embedCode;

	}



}

