<?php
/**
 * Class to manipulate data from User Video Galleries
 * 	 	
 * @access	public  	 
 */
class SG_TableVideoGalleries
{
	var $xmlContent = null;
	var $url = '';
	var $videofile = '';
	
	/**
	 * Return feedUrl of the video
	 */
	function getFeedUrl()
	{
	  $url=$this->url;
    try {
      $ch = curl_init($url);
      curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1); 
      curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 5);
      $data = curl_exec($ch);
      curl_close($ch);
      if (strstr($data,'not found')) $data="";
    } catch (Exception $e) {
      $data = @file_get_contents($url);
    }
    return $data;
	}
	
	function init($url)
	{
		$this->url = $url;
		$this->xmlContent	= $this->getFeedUrl();
		if(strstr($this->xmlContent,'<link rel="video_src"'))
		{
      preg_match_all('/<link rel="video_src".*?href\s*=\s*["\'](.+?)["\']/im', $this->xmlContent, $images);
      $this->videofile = str_replace('http://player.longtailvideo.com/player.swf?file=','',$images[1][0]);
  	}
	}
	
	/*
	 * Return true if successfully connect to remote video provider
	 * and the video is valid
	 */	 
	function isValid()
	{
		// Connect and get the remote video
		$this->xmlContent	= $this->getFeedUrl();
		$videoId = $this->getId();
		if(!strstr($this->xmlContent,'<link rel="video_src"'))
		{
			$this->setError	= JText::_('CC ERROR FETCHING VIDEO');
			return false;
		}
		
		return true;
	}
	
	/**
	 * Extract Blip video id from the video url submitted by the user
	 * 	 	
	 * @access	public
	 * @param	video url
	 * @return	videoid
	 */
	function getId()
	{
		$code	= '';
				
		//check for embed code format
		//$pos_e = strpos($this->url, "youtube.com/v/");
		$pos_u = strpos($this->url, "videoid=");

		////TODO: User regular expression instead
		if ($pos_u === false) {
			return null;
		} else if ($pos_u) {
			$pos_u_start = $pos_u + 8;

			$code = substr($this->url, $pos_u_start);
			$code = strip_tags($code );
			$code_tmp = explode("&", $code);
			$code = $code_tmp["0"];
		}
						
		return $code;
	}
	
	/**
	 * Return the video provider's name
	 * 
	 */
	function getType()
	{
		return 'uservideogalleries';
	}
	
	function getTitle()
	{
		$title = '';		
		// Store video title
		$pattern =  "/<title>(.*)<\/title>/i";
		preg_match_all($pattern, $this->xmlContent, $matches);
		if($matches)
		{
			$title = $matches[1][0];
		}
		
		return $title;
	}
	
	function getDescription()
	{
		$description = '';
		// Store description
		$pos_u = strpos($this->xmlContent, '<meta name="description" content="');
		////TODO: User regular expression instead
			$pos_u_start = $pos_u + 34;

			$code = substr($this->xmlContent, $pos_u_start);
			$code = strip_tags($code );
			$code_tmp = explode('"', $code);
			$code = $code_tmp["0"];
						
		return nl2br($code);
	}
	
	function getDuration()
	{
		$duration = '';
		return $duration;
	}
	
	/**
	 * Get video's thumbnail
	 * 
	 * @access 	public
	 * @param 	videoid
	 * @return url
	 */
	function getThumbnail()
	{
		$thumbnail = '';
		// Store thumbnail
		$pos_u = strpos($this->xmlContent, '<link rel="image_src" href="');
		////TODO: User regular expression instead
			$pos_u_start = $pos_u + 28;

			$code = substr($this->xmlContent, $pos_u_start);
			$code = strip_tags($code );
			$code_tmp = explode('"', $code);
			$code = $code_tmp["0"];
		
		return $code;
	}
	
	/**
	 * 
	 * 
	 * @return $embedvideo specific embeded code to play the video
	 */
	function getViewHTML($videoId, $videoWidth, $videoHeight)
	{
        $return = '<embed src="http://player.longtailvideo.com/player.swf?file='.$this->videofile.'" type="application/x-shockwave-flash" allowfullscreen="true" allowScriptAccess="always" width="425" height="344" />';
        return $return;
  }
  
}
