<?php
 /*
 // "Google Map" Plugin by Grigor Mihov for K2 v2.x - Version 1.0
 // Copyright (c) 2011 Grigor Mihov. StyleWare.EU. All rights reserved.
 // Released under the GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 // *** Last update: 3 April, 2011 ***
 */

// no direct access
defined('_JEXEC') or die ('Restricted access');
JLoader::register('K2Plugin', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2plugin.php');

class plgK2swmap extends K2Plugin {

	// Some params
	var $pluginName = 'swmap';
	var $pluginNameHumanReadable = 'Google Map';

	function plgK2swmap( & $subject, $params) {
	
		parent::__construct($subject, $params);
	}

	function onK2AfterDisplay( & $item, & $params, $limitstart) {
	
		global $mainframe;
	
		$plugin = & JPluginHelper::getPlugin('k2', 'swmap');
		$pluginParams = new JParameter($plugin->params);
		$view	= JRequest::getCmd('view');
		$plugins = new K2Parameter($item->plugins, '', $this->pluginName);
		$address = $plugins->get('address');
		$locale = $pluginParams->get('locale'); 
		$width = $pluginParams->get('defaultwidth'); 
		$height = $pluginParams->get('defaultheight'); 
		$defaultzoom = $pluginParams->get('defaultzoom');
		$zoom = $plugins->get('zoom', $defaultzoom );
		$type = $plugins->get('type', 'roadmap');
		$icon = $plugins->get('icon', 'landmark.png');
		$color = $pluginParams->get('color', 'blue');
		$introtext = mb_substr($item->introtext,0,150);
		
		if ($view == 'item' && $address !='')
		{
		$output = '

			<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false&language='.$locale.'"></script> 
			<script type="text/javascript">
			var geocoder;
			var map;
			var address ="'.$address.'";
			
			
			function initialize() {
			geocoder = new google.maps.Geocoder();
			var latlng = new google.maps.LatLng(-34.397, 150.644);
			var myOptions = {
			zoom: 18,
			center: latlng,
			mapTypeControl: true,
			mapTypeControlOptions: {style: google.maps.MapTypeControlStyle.DROPDOWN_MENU},
			navigationControl: true,
			mapTypeId: google.maps.MapTypeId.'.$type.'
			};
			map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
			

    if (geocoder) {
      geocoder.geocode( { \'address\': address}, function(results, status) {
        if (status == google.maps.GeocoderStatus.OK) {

          if (status != google.maps.GeocoderStatus.ZERO_RESULTS) {
		  
          map.setCenter(results[0].geometry.location);
            var infowindow = new google.maps.InfoWindow(
                { content: "<b>'.$item->title.'</b><br/><i>'.$address.'</i><br/>'.strip_tags(str_replace("\r","",str_replace("\n", "", str_replace("&nbsp;"," ",$introtext)))).'...",
				size: new google.maps.Size(150,50)
                });


            var marker = new google.maps.Marker({
                position: results[0].geometry.location,
				icon : \''. JURI::root() .'plugins/k2/swmap/'.$color.'/'.$icon.'\',
                map: map, 
                title:address
            }); 

            google.maps.event.addListener(marker,\'click\', function() {
                infowindow.open(map,marker);
            });

          } else {
            alert("No results found");
          }

        } else {

          alert("Geocode was not successful for the following reason: " + status);

        }

      });

    }

  }
  			window.addEvent("load",function(){initialize();});

</script>
<style>

#map_canvas {
	width: '.$width.'px;
	height: '.$height.'px;
	overflow: hidden;
	clear: both;
	margin-bottom: 20px;
	background: none !important;
}
#map_canvas img {
	background: none !important;
}
</style>
  <div id="map_canvas"></div>';
		}

		return $output;
	}
	
	function findtemId($cat){
	
	$db = JFactory::getDBO();
	
	$db->setQuery("SELECT id FROM #__menu WHERE link LIKE '%option=com_k2&view=itemlist&layout=category&task=category&id={$cat}' LIMIT 1");
	
	return $db->loadResult();
	
	
	}
	function onK2CategoryDisplay( & $category, & $params, $limitstart) {
	
		global $mainframe;
		$plugin = & JPluginHelper::getPlugin('k2', 'swmap');
		$pluginParams = new JParameter($plugin->params);
		$view	= JRequest::getCmd('view');
		$plugins = new K2Parameter($item->plugins, '', $this->pluginName);
		$locale = $pluginParams->get('locale', 'en'); 
		$color = $pluginParams->get('color', 'blue');
		$cattype = $pluginParams->get('cattype', 'ROADMAP');
		$catwidth = $pluginParams->get('catwidth'); 
		$catheight = $pluginParams->get('catheight'); 
		
		
		$db = JFactory::getDBO();
		
		$id = $category->id;
		$cats = array();
		
		if(!$id) $id = (int)$_GET['id'];
		
		$cats[] = $id;
		
		$level = array();
		
		$level[] = $id;
		do{
		$db->setQuery("SELECT id FROM #__k2_categories WHERE parent IN(".implode(",",$level).")");
	    $level = (array)$db->loadResultArray();
       
   	   if(is_array($level) && count($level) > 0){		
		
			$cats = array_merge((array)$cats,(array)$level);
		
		}
		else break;
		
		}while($db->getNumRows() > 0);
	
	if(empty($cats)) return null;
	
	$db->setQuery("SELECT * FROM #__k2_items WHERE catid  IN(".implode(",",$cats).")");
	
	unset($cats,$level);
	
	$items = array();
	
	$items = $db->loadObjectList();
	
	if(empty($items)) return null;
	
	$lats = array();
	$longs = array();
	$res = array();
	foreach($items as $item){
	
	$param = new K2Parameter($item->plugins, '', '');
	
	if(!$param->get('swmapaddress')) continue;
		
	$geocode=file_get_contents('http://maps.google.com/maps/api/geocode/json?address='.urlencode($param->get('swmapaddress')).'&sensor=false');

	$output= json_decode($geocode);

	$lat = $output->results[0]->geometry->location->lat;
	$long = $output->results[0]->geometry->location->lng;
	if(!$lat || !$long) continue;
	$items[$k]->lat = $lat;
	$lats[]=$lat;
	$items[$k]->long = $long;
	$longs[]=$long;
	
	
	$intro = JFilterOutput::cleanText($item->introtext);
	
	if(JString::strlen($intro) > 150){
	
	$intro = JString::substr($intro,0,147);
	$intro .='...';
	
	}
	
	$db->setQuery("SELECT alias FROM #__k2_categories WHERE id = {$item->catid} LIMIT 1");
	
	$link = K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($db->loadResult()));
	
	
	
	$link = "<a  href='".JRoute::_($link)."'>".$item->title."</a>";
	
	$res[] = array($item->title,$lat,$long,$param->get('swmapicon'),$intro,$link);
	
	
	
	
	
	}
	
	unset($items);
	
	$lat_min=min($lats);
	$lat_max=max($lats);
	
	$long_min = min($longs);
	$long_max = max($longs);
	
		
	
		$lat_center = ($lat_min + $lat_max)/2;
		$long_center = ($long_min + $long_max)/2;
		
		$output = '<div id="map_canvas"></div>
		<style>
		#map_canvas {
			width: '.$catwidth.'px;
			height: '.$catheight.'px;
			overflow: hidden;
			clear: both;
			margin-bottom: 20px;
		}
		#map_canvas img {
			background: none !important;
		}
		</style>
		<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=true&language='.$locale.'"></script> 
		<script type="text/javascript">
		window.addEvent("load",function(){initialize();});
		
		function initialize() {
			var myLatlng = new google.maps.LatLng('.$lat_center.', '.$long_center.');
			var myOptions = {
			zoom: 10,
			center: myLatlng,
			mapTypeControl: true,
			mapTypeControlOptions: {style: google.maps.MapTypeControlStyle.DROPDOWN_MENU},
			navigationControl: true,
			mapTypeId: google.maps.MapTypeId.'.$cattype.'
			}

			var map = new google.maps.Map(document.getElementById("map_canvas"),myOptions);
			google.maps.event.addListener(map, \'click\', function() {
			infowindow.close();
			});
			setMarkers(map, beaches);
		}
		
			var icons = new Array();
			icons["red"] = new google.maps.MarkerImage("'. JURI::root() .'plugins/k2/swmap/'.$color.'/landmark.png",
			new google.maps.Size(32, 32),
			new google.maps.Point(0,0),
			new google.maps.Point(0, 32));
		
		function getMarkerImage(iconColor) {
		if ((typeof(iconColor)=="undefined") || (iconColor==null)) {
		iconColor = "red";
		}
		
		if (!icons[iconColor]) {
		icons[iconColor] = new google.maps.MarkerImage("'. JURI::root() .'plugins/k2/swmap/'.$color.'/"+ iconColor +"",
		new google.maps.Size(32, 32),
		new google.maps.Point(0,0),
		new google.maps.Point(0, 32));
		}
		
		return icons[iconColor];
		}
		
		var iconImage = new google.maps.MarkerImage(\''. JURI::root() .'plugins/k2/swmap/'.$color.'/landmark.png\',
		new google.maps.Size(32, 32),
		new google.maps.Point(0,0),
		new google.maps.Point(0, 32));
		
		var infowindow = new google.maps.InfoWindow(
		{
		size: new google.maps.Size(150,50)
		});
		
		function createMarker(map, latlng, label,link, html, color) {
	
			var contentString = \'<b>\'+link+\'</b><br>\'+html;
			var marker = new google.maps.Marker({
			position: latlng,
			map: map,
			icon: getMarkerImage(color),
			title: label,
			zIndex: Math.round(latlng.lat()*-100000)<<5
		});
		
		google.maps.event.addListener(marker, \'click\', function() {
        infowindow.setContent(contentString);
		infowindow.open(map,marker);
        });
	}
	
	var beaches = '.json_encode($res).';
	
	function setMarkers(map, locations) {
		var bounds = new google.maps.LatLngBounds();
		for (var i = 0; i < locations.length; i++) {
		var beach = locations[i];
		var myLatLng = new google.maps.LatLng(beach[1], beach[2]);
		var marker = createMarker(map,myLatLng,beach[0],beach[5],beach[4],beach[3]);
		bounds.extend(myLatLng);
		map.fitBounds(bounds);
	}
}

</script>';
		return $output;
	}

	
}