<?php
/*------------------------------------------------------------------------
# plg_qk2autofacebook - Q Auto Facebook for K2 Joomla 1.5 Plugin
# ------------------------------------------------------------------------
# author    NetQ Creative Software, JSC
# copyright Copyright (C) 2010 Netqcreative.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://netqeative.com
# Technical Support:  Forum - http://netqeative.com/Support
-------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.error.error' );

// check for k2 extension
if (!JComponentHelper::getComponent('com_k2', true)->enabled) {
	JError::raiseWarning('5', 'K2AutoFacebook-Plugin - K2 Component is not installed or not enabled.');
	return;
}

require_once (JPATH_ROOT . DS . 'components' . DS . 'com_k2' . DS . 'helpers' . DS . 'route.php');
// add path to K2 tables
JTable::addIncludePath(JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_k2' . DS .'tables');

class plgSystemQk2autofacebook extends JPlugin
{
	protected $access_token  = '';
	protected $fanpage1 = '';	
	protected $fanpage2 = '';
	protected $optionpost = 0;
	protected $post_modified = 0;
	protected $postpublish = 0;
	protected $message_publish_post = '';
	// db table to get new item id
	protected $table_items	= '#__k2_items';

	var $pluginNameHumanReadable = 'K2 Auto Facebook';
	function plgSystemQk2autofacebook(&$subject, $params)
	{
		global $mainframe;
		parent::__construct($subject, $params);
		// Get Plugin info
		$plugin			=& JPluginHelper::getPlugin('system', 'qk2autofacebook');
		$pluginParams	= new JParameter($plugin->params);
		$this->access_token = $pluginParams->get('access_token', '');
		$this->fanpage1 = $pluginParams->get('fanpage1', '');
		$this->fanpage2 = $pluginParams->get('fanpage2', '');
		$this->optionpost = (int)$pluginParams->get('optionpost', 0);
		$this->post_modified = (int)$pluginParams->get('post_modified', 0);
		//post publish
		$this->postpublish = (int)$pluginParams->get('postpublish', 0);
		$this->message_publish_post = $pluginParams->get('message_publish_post', '');
	}
	
	private function getCategory($id)
	{
		$row =& JTable::getInstance('K2Category', 'Table');
		$row->load($id);
		return $row;
	}
	//show checkbox and text articles message in component k2 item
	function onAfterInitialise()
	{
		global $mainframe;
		// No remember me for admin
		if ($mainframe->isAdmin()) {
			$option = JRequest::getVar('option');
			$cid = JRequest::getVar('cid');
			$view = JRequest::getVar('view');
			$cid = JRequest::getVar('cid');

			if ($option == 'com_k2' && $view == 'item' && (($cid == '' ) || ($cid != '' && $this->post_modified))) {
				if (!empty($cid) && is_array($cid)){
					$cid = array_shift($cid);
				}
				JHTML::_('behavior.mootools');
				$checkboxt = array();
				$checkboxt[1] = "{id: '1', title: '', selected: false}";
				$textboxt[1] = "{id: 2, title: ''}";
				$checkboxt = '['.implode(', ', $checkboxt).']';
				$document = JFactory::getDocument();
				$document->addScriptDeclaration("function check_fbk2() { return {$checkboxt}; }");
				$document->addScript(JURI::root(true).'/plugins/system/qk2autofacebook/fbcheckboxk2.js');
			}
		}
	}
	
	function getFacebookClient()
	{
		$facebook = new Facebook(array(
			'appId' => '165562510146380',
			'secret' => '1a9e375af946ada5ee3eb92524a28e0c',
			'cookie' => true,
			));
		$session = $facebook->getSession();
		return $facebook;
	}

	protected function getID($table)
	{
		$db = &JFactory::getDBO();		
		$prefix = $db->getPrefix();
		$table = str_replace  ('#__', $prefix, $table);
		$query = 'SHOW TABLE STATUS LIKE ' . $db->Quote($table);
		$db->setQuery($query);
		$result = $db->loadAssoc();
		$next_key = (int)$result['Auto_increment'];
		return $next_key;
	}
	
	public function getDatapl($id, $typeinfo)
	{
		global $mainframe;
		$article =& JTable::getInstance('K2Item', 'Table');
		if ($article->load($id)) {
			$cat_name	= '';
			$cat_slug	= 0;
			$cat		=& $this->getCategory((int)$article->catid);
			$id_slug	= $id . ':' . JFilterOutput::stringURLSafe($article->alias);

			// post also correct url for article without category!
			if ($cat && (0 < $cat->id)) {
				$cat_name = $cat->name;
				$cat_slug = $cat->id . ':' . JFilterOutput::stringURLSafe($cat->alias);
			}
			// create url
			$url_ar = JString::strrpos(JURI::base(), '/administrator/');
			$baseurl = substr_replace(JURI::base(), '', $url_ar);
			$link = K2HelperRoute::getItemRoute($id_slug, $cat_slug);
			$urls = $baseurl.'/'.$link;
			// get title and metadescription of articles
			$title = $article->title;
			$metadesc = $article->metadesc;
			
			// Ckeck for an image in the path. If there is no image, try to use the first image in the article text.
			$imagefilename = md5("Image".$id);
			$imagepath = 'media/k2/items/src/'.$imagefilename . '.jpg';

			// check for the file
			if (!file_exists(JPATH_ROOT . DS . $imagepath)) {
				// if file does not exist, get the first image from the introtext and fulltext
				$doc = new DOMDocument();
				$img_parsetext = $article->introtext . $article->fulltext;
				@$doc->loadHTML($img_parsetext);
				$imgtags = $doc->getElementsByTagName('img');
				if (0 < $imgtags->length) {
					$imgtag = $imgtags->item(0);
					$image = $baseurl.'/'.$imgtag->getAttribute('src');
				} else {
					$image = '';
				}
			} else {
				// use image form path
				$image = $baseurl.'/'.$imagepath;
			}
			$messige = $this->message_publish_post;
			
			
			try {		
				$url = "https://graph.facebook.com/me/feed";
				$client = self::getFacebookClient();
				$attachment =  array(
					'access_token' => $this->access_token,
					'message' => $messige,
			        'name' => $title,
			        'link' => $urls,
			        'description' => $metadesc,
			        'picture'=> $image);
				//access_token2
				$attachment_fanpage1 =  array(
					'access_token' => $this->fanpage1,
					'message' => $messige,
			        'name' => $title,
			        'link' => $urls,
			        'description' => $metadesc,
			        'picture'=> $image);
				//access-token3
				$attachment_fanpage2 =  array(
					'access_token' => $this->fanpage2,
					'message' => $messige,
			        'name' => $title,
			        'link' => $urls,
			        'description' => $metadesc,
			        'picture'=> $image);
				// set the target url
				
				$postto = $this->optionpost;
			    $default = $this->access_token;
			    $fanpage1 = $this->fanpage1;
			   	$fanpage2 = $this->fanpage2;
			    if($postto == 0) { 
			    	if(!empty($default)) {
			    		$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}	
				   	if (!empty($fanpage1)) {
				   		$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment_fanpage1);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}
				   	if (!empty($fanpage2)) {
				   		$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment_fanpage2);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}
			   	} elseif($postto == 1) {
			   			$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
			   			curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment);
			   			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
			   	} else {
			   		if (!empty($fanpage1)) {
			   			$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment_fanpage1);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}
				   	if (!empty($fanpage2)) {
				   		$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment_fanpage2);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}
			   	}	
		   		$mainframe->enqueueMessage('Article posted to your Facebook wall successfully!');
			}
			catch(Exception $e) {
				JError::raiseWarning('1', ' - Error - Maybe your plugin set up is incorect please check it again.');
			}		
		}
		
	}
	
	public function getData($id, $typeinfo)
	{
		global $mainframe;
		$article =& JTable::getInstance('K2Item', 'Table');
		if (!empty($id)) {
			$article->load($id);
			$cat_name	= '';
			$cat_slug	= 0;
			$cat		=& $this->getCategory((int)$article->catid);
			$id_slug	= $id . ':' . JFilterOutput::stringURLSafe(JRequest::getVar('alias'));

			// post also correct url for article without category!
			if ($cat && (0 < $cat->id)) {
				$cat_name = $cat->name;
				$cat_slug = $cat->id . ':' . JFilterOutput::stringURLSafe($cat->alias);
			}
			// create url
			$url_ar = JString::strrpos(JURI::base(), '/administrator/');
			$baseurl = substr_replace(JURI::base(), '', $url_ar);
			$link = K2HelperRoute::getItemRoute($id_slug, $cat_slug);
			$urls = $baseurl.'/'.$link;
		} else {
			$id = $this->getID($this->table_items);
			$cat_name	= '';
			$cat_slug	= 0;
			$cat		=& $this->getCategory((int)JRequest::getVar('catid'));
			$id_slug	= $id . ':' . JFilterOutput::stringURLSafe(JRequest::getVar('alias'));

			// post also correct url for article without category!
			if ($cat && (0 < $cat->id)) {
				$cat_name = $cat->name;
				$cat_slug = $cat->id ;
			}
			// create url
			$url_ar = JString::strrpos(JURI::base(), '/administrator/');
			$baseurl = substr_replace(JURI::base(), '', $url_ar);
			$link = K2HelperRoute::getItemRoute($id_slug, $cat_slug);
			$urls = $baseurl.'/'.$link;
		}
		$title = JRequest::getVar('title');
		$metadesc = JRequest::getVar('metadesc');
		$messige = JRequest::getVar('messagefbk2');
		//get image in articles
		$text = JRequest::getVar('text', '', 'post', 'STRING', JREQUEST_ALLOWHTML);
		preg_match_all('/src="([^"]+)"/i', $text, $matches);
		if(empty($matches[1][0])) {
			$image = "";
		} else {
			$image = $baseurl.'/'.$matches [1] [0];//show images
		}
		try {
			$url = "https://graph.facebook.com/me/feed";
				$client = self::getFacebookClient();
				$attachment =  array(
					'access_token' => $this->access_token,
					'message' => $messige,
			        'name' => $title,
			        'link' => $urls,
			        'description' => $metadesc,
			        'picture'=> $image);
				//access_token2
				$attachment_fanpage1 =  array(
					'access_token' => $this->fanpage1,
					'message' => $messige,
			        'name' => $title,
			        'link' => $urls,
			        'description' => $metadesc,
			        'picture'=> $image);
				//access-token3
				$attachment_fanpage2 =  array(
					'access_token' => $this->fanpage2,
					'message' => $messige,
			        'name' => $title,
			        'link' => $urls,
			        'description' => $metadesc,
			        'picture'=> $image);
				// set the target url
				
				$postto = $this->optionpost;
			    $default = $this->access_token;
			    $fanpage1 = $this->fanpage1;
			   	$fanpage2 = $this->fanpage2;
			    if($postto == 0) { 
			    	if(!empty($default)) {
			    		$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}	
				   	if (!empty($fanpage1)) {
				   		$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment_fanpage1);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}
				   	if (!empty($fanpage2)) {
				   		$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment_fanpage2);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}
			   	} elseif($postto == 1) {
			   			$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
			   			curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment);
			   			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
			   	} else {
			   		if (!empty($fanpage1)) {
			   			$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment_fanpage1);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}
				   	if (!empty($fanpage2)) {
				   		$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$url);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
						curl_setopt($ch, CURLOPT_POST, true);
				   		curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment_fanpage2);
				   		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output
						$result = curl_exec($ch);
				   	}
			   	}	
		   		$mainframe->enqueueMessage('Article posted to your Facebook wall successfully!');
			}
		catch(Exception $e) {
			JError::raiseWarning('1', ' - Error auto Facebook - ');
		}
	}
	
	function onAfterRoute()
	{
		global $mainframe;
		if ('com_k2' == JRequest::getVar('option')) {
			require_once (JPATH_ROOT . DS . 'plugins' .DS. 'system' .DS. 'qk2autofacebook' .DS. 'facebook.php');
			$task	= JRequest::getVar('task', '');
			$view	= JRequest::getVar('view', '');
			$postfbk2 = JRequest::getVar('postfbk2');
			$id = JRequest::getVar('id', '');
			// check informatinon plugin 
			if ((!empty($postfbk2)) && ($this->access_token == '')) {
				JError::raiseWarning('2', ' - The Q Auto Facebook plugin setting wasn\'t correct, Article wasn\'t posted to the Facebook wall');
			return false;
			}
			// post article to facebook
			if ((('item' == $view) && !empty($postfbk2) && (('apply' == $task) || ('save' == $task) || ('saveAndNew' == $task)))
				&&	(1 == (int)JRequest::getVar('published', 0))) {
				$this->getData($id, $typeinfo);
			}
			//publish post
			if ($this->postpublish) {
				if (('items' == $view) && ('publish' == $task)) {
					$ids	= JRequest::getVar('cid');
					$article =& JTable::getInstance('K2Item', 'Table');
					foreach ($ids as $id) {
						$article->load($id);
						$this->getDatapl($id, $typeinfo);
					}
				}
			}	
		}		
		return true;
	}
}
